//+------------------------------------------------------------------+
//|                                                     Impulse2.mq4 |
//|                                      Copyright  2012, Dmitry I. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Dmitry I."
#property link      "http://www.metaquotes.net"

extern double StopLoss   =1000;     
extern double TakeProfit =150;
extern double TrailingStop = 20;
extern double TrailingStep = 5;
extern double DDep = 0.1;
extern bool Breakeven = true;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("Leverage");
   ObjectDelete("Spead");
   ObjectDelete("StopLevel");
   ObjectDelete("BALANCE");
   ObjectDelete("EQUITY"); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
 
  //-------------------------------------------------------------
 //Signs
   
 ObjectCreate("Leverage", OBJ_LABEL, 0, 0, 0, 0, 0);
    ObjectSet("Leverage", OBJPROP_CORNER, 2);
    ObjectSet("Leverage", OBJPROP_YDISTANCE, 15);
    ObjectSet("Leverage", OBJPROP_XDISTANCE, 10);
ObjectSetText("Leverage", "Leverage " + AccountLeverage(), 8, "Tahoma", Yellow); 
    ObjectCreate("Spead", OBJ_LABEL, 0, 0, 0, 0, 0);
    ObjectSet("Spead", OBJPROP_CORNER, 2);
    ObjectSet("Spead", OBJPROP_YDISTANCE, 30);
    ObjectSet("Spead", OBJPROP_XDISTANCE, 10);
ObjectSetText("Spead", "Spead " + DoubleToStr((Ask - Bid) / Point, 0), 8, "Tahoma",Yellow );  
if((Ask - Bid)/Point>18)ObjectSet("Spead", OBJPROP_COLOR, Red);
    ObjectCreate("StopLevel", OBJ_LABEL, 0, 0, 0, 0, 0);
    ObjectSet("StopLevel", OBJPROP_CORNER, 2);
    ObjectSet("StopLevel", OBJPROP_YDISTANCE, 45);
    ObjectSet("StopLevel", OBJPROP_XDISTANCE, 10);
ObjectSetText("StopLevel", "StopLevel " + DoubleToStr(MarketInfo(Symbol(), MODE_STOPLEVEL),0), 8, "Tahoma",Yellow );
if(MarketInfo(Symbol(), MODE_STOPLEVEL)>20)ObjectSet("StopLevel", OBJPROP_COLOR, Red);  
    ObjectCreate("BALANCE", OBJ_LABEL, 0, 0, 0, 0, 0);
    ObjectSet("BALANCE", OBJPROP_CORNER, 2);
    ObjectSet("BALANCE", OBJPROP_YDISTANCE, 60);
    ObjectSet("BALANCE", OBJPROP_XDISTANCE, 10);
ObjectSetText("BALANCE", "BALANCE " + DoubleToStr(AccountBalance(),2), 8, "Tahoma",Aqua );  
    ObjectCreate("EQUITY", OBJ_LABEL, 0, 0, 0, 0, 0);
    ObjectSet("EQUITY", OBJPROP_CORNER, 2);
    ObjectSet("EQUITY", OBJPROP_YDISTANCE, 75);
    ObjectSet("EQUITY", OBJPROP_XDISTANCE, 10);
ObjectSetText("EQUITY", "EQUITY " + DoubleToStr(AccountEquity(),2),12, "Tahoma",Lime ); 
//+------------------------------------------------------------------+ 
// 
    if ((Open[4] > Close[4] && Open[3] > Close[3] && Open[2] > Close[2] && Open[1] + 10*Point < Close[1]) ||
       (Open[4] > Close[4] && Open[3] > Close[3] && Open[2] > Close[2] + 10*Point && Open[1] < Close[1])) int Buy = 1;
    
    if ((Open[4] < Close[4] && Open[3] < Close[3] && Open[2] < Close[2] && Open[1] > Close[1] + 10*Point) ||
       (Open[4] < Close[4] && Open[3] < Close[3] && Open[2] + 10*Point < Close[2] && Open[1] > Close[1])) int Sell = 1;

//-------------------------------------------------------------------
//   
   
   RefreshRates();                              
   double Min_Lot=MarketInfo(Symbol(),MODE_MINLOT);
   double Max_Lot=MarketInfo(Symbol(),MODE_MAXLOT);        
   double Free   =AccountFreeMargin();                 
   double One_Lot=MarketInfo(Symbol(),MODE_MARGINREQUIRED);
   double Step   =MarketInfo(Symbol(),MODE_LOTSTEP); 
   
   double Multi = 0.1;
   
   double Lot = MathFloor(Free*DDep*Multi/One_Lot/Step)*Step;     
   
   if (Lot < Min_Lot) Lot = Min_Lot;
   if (Lot > Max_Lot) Lot = Max_Lot;
   
   if (Lot*One_Lot > Free)                      
     {
      Print(" Not enough money for ", Lot," lot");
      return;                                   
     }
//--------------------------------------------------------------- 8 --
   //  
   if (OrdersTotal() < 1 && Buy > 0)
    {
     RefreshRates();
     int Tic=OrderSend(Symbol(),OP_BUY,Lot,Ask,2,Bid - StopLoss*Point, Bid + TakeProfit*Point, 0, 111, 0, Green);
     if (Tic > 0) Buy = 0;
     if (Tic < 0) GetLastError();
    } 
   
   if (OrdersTotal() < 1 && Sell > 0)
    {
     RefreshRates();
     Tic=OrderSend(Symbol(),OP_SELL,Lot,Bid,2,Ask + StopLoss*Point, Ask - TakeProfit*Point, 0, 111, 0, Green);
     if (Tic > 0) Sell = 0;
     if (Tic < 0) GetLastError();
    } 
//--------------------------------------------------------------- 8 --
   //  
for(int i=1; i<=OrdersTotal(); i++)
      {
      if (OrderSelect(i-1,SELECT_BY_POS, MODE_TRADES))
        {
 //Breakeven
        RefreshRates();
        if (Breakeven)
         { 
         if (OrderType()==OP_BUY && Bid - OrderOpenPrice() > 20*Point && OrderStopLoss() < OrderOpenPrice())
          {
           bool Break=OrderModify(OrderTicket(),OrderOpenPrice(),Bid - 20*Point, OrderTakeProfit(),0 ,CLR_NONE); 
           if (Break == false) GetLastError();                       
          }
         
         if (OrderType()==OP_SELL && OrderOpenPrice() - Ask > 20*Point && OrderStopLoss() > OrderOpenPrice())
          {
           Break=OrderModify(OrderTicket(),OrderOpenPrice(),Ask + 20*Point, OrderTakeProfit(),0 ,CLR_NONE); 
           if (Break == false) GetLastError();                       
          }
         }  //end of Breakeven
 
 //TrailingStop
       
       if (OrderType()==OP_BUY && OrderStopLoss() != 0 && OrderStopLoss() != Bid - TrailingStop*Point)
         {
          if (Bid - OrderOpenPrice() > TrailingStop*Point)
           {
            if (OrderStopLoss() < Bid - (TrailingStop + TrailingStep)*Point)
             {
               bool kk=OrderModify(OrderTicket(), OrderOpenPrice(), Bid - TrailingStop*Point, OrderTakeProfit(), 0, Red);
               if (kk == false) GetLastError();
             }
           }
         }    
       if (OrderType()==OP_SELL && OrderStopLoss() != 0 && OrderStopLoss() != Ask + TrailingStop*Point)
         {
          if (OrderOpenPrice() - Ask > TrailingStop*Point)
           {
            if (OrderStopLoss() > Ask + (TrailingStop + TrailingStep)*Point)
             {
               kk=OrderModify(OrderTicket(), OrderOpenPrice(), Ask + TrailingStop*Point, OrderTakeProfit(), 0, Red);
               if (kk == false) GetLastError();
             }
           }
         }      
       
       }  //end of OrderSelect
      }   //end of for
//----
   return(0);
  }
//+------------------------------------------------------------------+